
 #define Version "2020_1004"
#define FOSC_INTERNE
/*
04/10/2020
Test sur carte Microchip  IDRA demo Board1 avec 16F887 (au lieu de 16F877)
PIC   Fosc interne 8MHz
//avec prescaler 1/1
// mini avec PR2=255  Duty 8 bits      490 Hz
//avec prescaler 1/1
// maxi avec PR2= 255 Duty 8 bits   7 860 Hz
// maxi avec PR2=9    Duty sur 3 bits seuleement
at 20MHz
04/10/2020
PIC   Fosc interne Q=20 MHz
//avec prescaler 1/16
// mini avec PR2=255 Duty 8  bits     1 220 Hz
//avec prescaler 1/1
// maxi avec PR2=255 Duty 8  bits    19 577  Hz
// Maxi avec PR2=9    Duty 3 bits    500 000Hz
// Maxi avec PR2=4    Duty 2 bits    1 000 000Hz
*/

 //#define Version "2020_1003"
 // test Maxima
// ATTENTION : 16F887 au lieu de 16F877
// enlev l'oscillateur 20MHz pour pouvoir utiliser l'Oscillateur Interne du 16F887
// at 8MHz
// minma Freq PWM = 490Hz avec prescaler 1/16 FOSC=8MHz et resolution maxi 0  255
//#define Version "2020_1003"
#define PWM_8bits

#define With_LCD
#define With_ADC

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F877_IRDA_Board"
#define Project "16F887_IRDA_board_Tests_PWM_with_Fosc_8Mhz_2020.mcppi"
#define Source "_16F887_Irdaboard_Tests_PWM_at_8Mhz_2020_1004.c"
#define EEPROM "16F887_IRDA_daboard_Tests_minima_Freq_PWM_with_Fosc_8Mhz_2020_EEPROM.ihex"
#define FOSC " Internal FOSC 8MHz"
// CONFIG1 : $2007 : 0x2CF5
// CONFIG2 : $2008 : 0x0700
// Internal FOSC 8MHZ

#define With_LCD 
#define With_UART     

// Lcd OCULAR OM16241   2 lignes de 16 cars pinout settings
sbit LCD_RS at RA3_bit;
sbit LCD_RW at RA2_bit;
sbit LCD_EN at RA1_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D4 at RB0_bit;

// Pin direction
sbit LCD_RS_Direction at TRISA3_bit;
sbit LCD_RW_Direction at TRISA2_bit;
sbit LCD_EN_Direction at TRISA1_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;

sbit Reset_MCP2150 at RC0_bit ;
sbit Reset_MCP2150_dir at TRISC.B0 ;


sbit LCD_PWR at RD5_bit;     // to power on the LCD
sbit LCD_PWR_direction at TRISD.B5;     // to power on the LCD
//      SW1 MCLR  reset or VPP input
//#define SW2 PORTA.RA5        // Switch2 avec rappel au +5V
//#define SW3 PORTA.RA4        // Switch1 avec rappel au +5V
sbit SW2 at PORTA.B5 ;       // Switch2 avec rappel au +5V
sbit SW3 at PORTA.B4 ;       // Switch1 avec rappel au +5V
sbit SW2_direction at TRISA5_bit;
sbit SW3_direction at TRISA.B4;

//#define   Led_Verte_D0 RD0_bit
#//define   Led_Verte_D1 RD1_bit
#define   Led_Verte_D2 RD2_bit
#define   Led_Verte_D3 RD3_bit
#define   Led_Verte_D4 RD4_bit
#define   Led_Verte_D5 RD5_bit
#define   Led_Verte_D6 RD6_bit
#define   Led_Verte_D7 RD7_bit
sbit Led_Verte_D0 at RD0_bit ;
sbit Led_Verte_D1 at RD1_bit  ;

sbit SQA at RD6_bit ;
sbit SQA_Dir at TRISD.B6 ;

#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256

#define Highest(param) ((char *)&param)[3]
#define Higher(param) ((char *)&param)[2]
#define Hi(param) ((char *)&param)[1]
#define Lo(param) ((char *)&param)[0]


#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256


#define CLS 12
#define CR 13
#define LF 10
#define BS 8
#define TAB 9
 

const code char mesg0[]=" MikroC 7.60. & Microchip IRDA board 16F887 (ex 16F877)\r\n";
const code char mesg1[]=" Directory : "Directory"\r\n";
const code char mesg2[]=" Project : "Project"\r\n";
const code char mesg3[]=" Source : "Source"_"Version".c\r\n";
const code char mesg4[]=" Fosc ="FOSC"\r\n";
const code char mesg5[]=" EEPROM : "EEPROM"\r\n";
const code char mesg6[]=" TEST PWM : sortie sur RC2  \r\n";
const code char mesg7[]=" consigne PWM via Keyboard ou potar sur EA0 \r\n";
const code  char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7};


#define MAXLEN1 32
//unsigned char Table[MAXLEN1] absolute 0x01A0;  // into bank3
volatile unsigned char Buffer1[MAXLEN1] absolute 0x20;
unsigned char DutyVal ;       // the PWM value
volatile unsigned char c1;
volatile int Index1,  CptErr,i1;
//volatile int count ;
volatile int EA0;
char *p1;
char CRam1[18];
unsigned char cx;
unsigned int i,j,k;

// unsigned long L1;
//unsigned int M1;  // ADC0 measure
//int BP1,BP2;
//unsigned char Idx;
//float F1;


volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned Togle:1;
                 unsigned See:1;
                 unsigned standby:1;
                 unsigned Full:1;
                 unsigned Duty_Cde_Mode:1;
               }Drapeaux ;




void Lcd_Out(char row, char column, char *text);
void Lcd_Out_Cp(char *text);
void Lcd_Chr_Cp(char out_char);
void Lcd_Cmd(char out_char);

#define Print UART1_Write_Text
void CPrint(const char *txt);
void CRLF1(void);


//---- EEPROM PIC  bytes  ================
unsigned char EEPROM_Lect(unsigned char adrE) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned char PtrE);  //  for 16Fxxxxx

#define  Put_RS   UART1_Write


void Interrupts() iv 0x0004 ics ICS_AUTO
 {
    if ((RCIE_bit==1) && (RCIF_bit==1) )
    {
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       _asm nop;
       RCSTA.CREN = 1 ;
        CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      _asm nop;
      RCSTA.SPEN= 1 ;
      CptErr++;
      }
      c1=RCREG;
     // optional echo de la reception
     TXREG=c1;
     if (c1==CR)
      {
      Drapeaux.Full=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      Buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        Buffer1[i1]=c1;
        Index1=i1;
        i1++;
       
      }
    }
  /*------ Timer0 --------------
    if ((T0IE_bit)&&(TMR0IF_bit))
      {  
         TMR0IF_bit    = 0;
         TMR0       = 60;         //with  Q=20Mhz  prescaler 1:256 =>   (255-60)*256*0.25   =10035 S   ~10mS
         count++;                  //Increase counter by one
        if (count >= 10)         //Adjust this value for different time (10ms x XX)
        {
         Drapeaux.Elligible=1;  
         count = 0;
         }
      }
   */  
 }




//------  EEPROM du PIC18Fx6K22 ---------------

unsigned char EEPROM_Lect(unsigned char AdrE) // lecture a l'adresse adr
{  
     EEADR =(unsigned char) AdrE & 0x00FF;
    //EEADRH =0;
        EECON1.EEPGD=0;     // 0= adressage sur EEPROM , 1=sur flash
      // EECON1.CFGS=0;      // 0= acces data EEPROM
        EECON1.RD=1;        // arme Lecture EEprom
       while( EECON1.RD=1);  // wait RD=0
        return(EEDATA);
}

//void EEPROM_Ecr(unsigned char AdrE,unsigned char car) // ecrit  a l'adresse adrE
void EEPROM_Ecr(unsigned char AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
   if(INTCON.GIE ==1)
   {
   INTCON.GIE =0 ;
    dr=1;
   } 
    while( EECON1.WR==1); 
    EEADR =AdrE ;
    EEDATA=car;   
    EECON1.EEPGD=0;
    EECON1.WREN=1;  
   EECON1.WRERR=0;    
    EECON2=0x55;
    EECON2=0xAA; 
    EECON1.WR=1; 
    // test si fin d'ecriture
   while ( EECON1.WR ==1); 
    // ou rajout delay   
    // Delay_ms(20);
    PIR2.EEIF=0;    // to be sure
    EECON1.WREN=0;  
   if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned char adrx, unsigned char * ptr1)
{   while ((*ptr1>0) && (adrx<256))
        {
         EEPROM_Ecr(adrx++,*ptr1++);
         Delay_ms(20);        
         }
}

void _PrintOut_Eeprom_Msg(unsigned char PtrE)
{ unsigned char c;
  do
  {
  c = EEPROM_Lect(PtrE);
  if ( c>0) Put_RS(c);
  PtrE++;
   Delay_ms(20);
  }
  while ((c!=0) && (PtrE<255))  ;
}

void PrintOut_Eeprom_Msg(unsigned char PtrE)
{ unsigned char c;
  do
  {
  c = EEPROM_Read(PtrE);
  if ( c>0) Put_RS(c);
  PtrE++;
   Delay_ms(20);
  }
  while ((c!=0) && (PtrE<255))  ;
}


 // --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source) {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CPrint(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void CRLF1()
 { UART1_Write(13);
  UART1_Write(10);
  }
  
void Raz_Uart(void)
{
      for (Index1=0;Index1<MAXLEN1;Index1++) Buffer1[Index1]=0;
       Index1=0;
       i1=0;
       Drapeaux.Full=0;
      c1 = RCREG;
      c1=0;
      p1=0;
      RCIE_bit=1;
}

  void ADC_Init()
{
   ADCON0 = 0x81;  // ADON = 1, Channel A.0 select, Fosc/32 select
   ADCON1 = 0x8E;  // 0x8E    port A0 as analog, right justified output
}

unsigned int ADC_Average_of_16_Reading(unsigned char channel)
{
  int i;
  static unsigned int  avg_output=0;
  unsigned int temp=0 ;
  unsigned int RawM=0;
  //unsigned int digital_out[20];  // genere warning IRP_bit ........
  if(channel > 7) return 0;
  ADCON0 &= 0xC7;        // AND= RAZ channel selection
  ADCON0 |= channel<<3; // OR = Set  chanel selection
  Delay_ms(3);
  for(i=0;i<16;i++)
  {
     GO_bit = 1;
     _asm NOP  //  allways one instruction after setting bit GO  (MicroChip recommandation)
      while(GO_bit);  // Wait until conversion gets over
     RawM=(unsigned int) (ADRESH<<8) + ADRESL ;   // Store 10-bit output into a 16-bit variable
     temp=temp+RawM;
     if (Drapeaux.See==1)
     {
      if ((i % 8)==0)
      {
       CRLF1();
        CPrint(" EA0 => ");
        }
      WordToStr(RawM,CRam1);
      Print(CRam1);    UART1_Write(TAB);
     }
     Delay_ms(1);
  }
  avg_output=temp>>4;    // use SHIFT to divide by 16 to avoid use of maths.h
return(avg_output);
}

void main()
{
#ifdef FOSC_INTERNE
 // OSCCON=0;
 // OSCCON.IRCF2=1;
 // OSCCON.IRCF1=1;
 // OSCCON.IRCF0=1;
 // OSCCON.SCS=1;
  OSCCON=0b01110001 ; // 8MHz (111) & SCS=1  (sinon 4 MHz par defaut)
 #endif
 
  TRISA=0b11110001 ;
  ANSEL  = 0;  // Configure AN pins as digital I/O
  ANSEL=0x01; // RA0 = Analog input
  ANSELH = 0;
  C1ON_bit = 0;                      // Disable comparators
  C2ON_bit = 0;
  TRISB=0xFF;
  TRISC=0xFF;

  ADCON1=0x8E;      // RA0=Analog other as digital portA   Right justified
  TRISC=0b10111011 ;  // RC2 en sortie pour PWM
  TRISD=0b00000000 ;
  TRISB=0b11110000 ;
  PORTA=0;
  Reset_MCP2150_dir=0 ;   // pour usage de RX interrupt
  SW2_direction=1; //RA5;
  SW3_direction=1; //RA4;

  SQA_Dir=0;  //RD6 ;
  SQA=0;
  
  
  for (Index1=0;Index1<MAXLEN1;Index1++) Buffer1[Index1]=0;
  Index1=0;
  i1=0;
  Drapeaux.Full=0;
  p1=&Buffer1[0];
 
   // Initialize UART module at 19200 bps
  UART1_Init(19200);
  CRLF1();
  
  
 // CPrint(" Presentation =IRP_bit probleme\r\n");

  CPrint(" Presentation : \r\n");
  for (i=0;i<7;i++)
  {
  SQA+1;
  CPrint(Messages[i]);
  SQA=0;
  }
 CRLF1();

  
  CPrint(" Reset du MCP2150, pour utiliser RX UART\r\n");
  Reset_MCP2150=0;   // reset MCP2150
  CptErr=0;

  UART1_Write(CLS);
  Delay_ms(500);
  
  //PrintOut_Eeprom_Msg(0); // message deja en eepropm


 // L1=Get_Fosc_kHz();
 // Print("Freq kHz= ");
 // LongToStr(L1, CRam1);
 // Print(CRam1);
 // CRLF1();
  
   #ifdef With_ADC
  CPrint("ADC Init\r\n");
  ADC_Init();
  #endif
  
 // === test ========

// ========================

  CPrint(" Init LCD\r\n");
   // Initialize LCD
   CPrint(" Power On (RD5) and Init LCD\r\n");
   // Initialize LCD
  PORTD=0;
  // RD5 =LCD_PWR voir schema 103-00032 en C2
  LCD_PWR=1;   // RD5 =LCD_PWR voir schema 103-00032 en C2
  Lcd_Init();
//            1234567890123456
  Lcd_Cmd(_LCD_FIRST_ROW );
  strcpy(CRam1,"16F887 IRDAboard");
  Lcd_Out_CP(CRam1); 
  Delay_ms(2000);
  Lcd_Cmd(_LCD_SECOND_ROW );
  strcpy(CRam1,"PWM output onRC2");
  Lcd_Out_CP(CRam1);
  Delay_ms(1000);
  //CPrint(" Prescaler=1/1, at 8MHz PR2=255 Resolution 8b\r\n PWM Frequency on RC2 => 7860 Hz\r\n");
  //CPrint(" Prescaler=1/1, at 8MHz PR2=9  faible Resolution 3b\r\n PWM Maxi Frequency on RC2 => 200 KHz\r\n");
  //CPrint(" Prescaler=1/1 at 20Mhz PR2=4 tres faible Resolution 2b\r\n PWM Maxi Frequency on RC2 => 1MHz\r\n");
   TMR2IE_bit=0;
  //PWM1_Init(2000);
   SQA=1;
   TRISC2_bit=1;   // RC2 PWM input
  // REGISTER 8-1: CCP1CON REGISTER/CCP2CON REGISTER (ADDRESS 17h/1Dh)
   //bit 3-0 CCPxM3:CCPxM0: CCPx Mode Select bits    11xx = PWM mode
   CCP1CON=0x0C;
   CCP2CON=0x0C;
   // TMR2 used for CCP1 PWM output
  //REGISTER 7-1: T2CON: TIMER2 CONTROL REGISTER (ADDRESS 12h)
  //  TOUTPS3 TOUTPS2 TOUTPS1 TOUTPS0 TMR2ON T2CKPS1 T2CKPS0
  //The input clock (FOSC/4) 
  // pass trough a prescale option of 1:1=00, 1:4=01 or 1:16=10, selected by control bits
   //T2CKPS1:T2CKPS0 (T2CON<1:0>).
  // bit 6-3 TOUTPS3:TOUTPS0: Timer2 Output Postscale Select bits  de 1/1=0000  1/16 =1111
  //T2CON = 0b00000100;     // TMR2 ON, postscale 1:1, prescale 1:1
  // Post Scaler Timer2   = 1/16   NOT used by 16F887   , OK with 16F877
  TOUTPS3_bit=1;
  TOUTPS2_bit=1;
  TOUTPS1_bit=1;
  TOUTPS0_bit=1;

    // prescaler Timer2   1/1
  T2CKPS1_bit=1;
  T2CKPS0_bit=0;
  // at 8Mhz => 0,5S   0.5*1=> tick = 0.5S
  PR2 = 255;   //   PWM period (255+1)*0.5=> 127S   => 7812 Hz   (19577 Hz  FOSC=20MHz)
  DutyVal=127;  // 50%
//  PR2 = 9;   //    PWM period (9+1)*0.5=> 5S   => 200 000 Hz        ( 500Khz at FOSC=20Mhz)
//  DutyVal=4;  // 50%
  CCPR1L=DutyVal;
  SQA=1;
  TMR2ON_bit=1;
  SQA=0;
  TRISC2_bit=0;
  
  // for UART interrupt
  Index1=0;
  Drapeaux.Full=0;
  i1=0;
  Index1=0;
  CREN_bit=1;
  PEIE_bit=1;
  RCIE_bit=1;
  GIE_bit=1;
  Drapeaux.Duty_Cde_Mode=0;

   CPrint(" Test PWM  at FOSC=20MHz  Post-scaler Non Utilis! PR2=255\r\n"
    " Prescaler  :  avec 1/16  Freq= 490 Hz \r\n"
    " Choix Prescaler : HIGH  MEDIUM  LOW \r\n"
    " Duty_Cde_Mode via Keyboard  Duty=xxx\r\n");
    CRLF1();
  
 Drapeaux.See=1;

  while(1)
  {
     Raz_Uart();
    Delay_1sec();
    if(Drapeaux.Full==1)
    {
      //Reu :Duty= 125
      CPrint("\r\nReu :");
      Print(Buffer1);
      p1=strstr(Buffer1,"Duty=");
      if (p1>0)
      {
        *(p1+8)=0;
        // atoi ou alors :
         k=     ( *(p1+5)-48)*100;
         k= k + ( *(p1+6)-48)*10;
         k= k + ( *(p1+7)-48)*1;

        // k=atoi(p1+5);
         WordToStr(k,CRam1);
         Print(CRam1);
         UART1_Write(TAB);
         if ((k>0) && (k<200))
         {
         DutyVal=(unsigned char)(k & 0x00FF);
         TMR2ON_bit=0;  //PWM1_Stop();
         CCPR1L=DutyVal; //PWM1_Set_Duty(DutyVal);
         TMR2ON_bit=1; //PWM1_Start();
          CPrint(" -> OK \r\n ");
           Drapeaux.Duty_Cde_Mode=0;
         }
         else
         {  WordToStr(k,CRam1);
            CPrint("Bad value : ");
            Print(CRam1);
            CRLF1();
         }
       }
        p1=strstr(Buffer1,"ANA_ON");
        if (p1>0) 
        {
          Drapeaux.Duty_Cde_Mode=1;
          CPrint("\r\n Duty_Cde_Mode f(EA0)\r\n");
        }
        p1=strstr(Buffer1,"ANA_OFF");
        if (p1>0) 
        {
           Drapeaux.Duty_Cde_Mode=0;
           CPrint("\r\n Duty_Cde_Mode via Keyboard\r\n");
        }
          p1=strstr(Buffer1,"HI");
        if (p1>0)
        {
          TMR2ON_bit=0;
          CPrint("\r\n set Prescaler  1/1 \r\n");
          T2CKPS1_bit=0;
          T2CKPS0_bit=0;
          TMR2ON_bit=1;
        }
          p1=strstr(Buffer1,"LO");
        if (p1>0)
        {
          TMR2ON_bit=0;
          CPrint("\r\n set Prescaler  1/16 \r\n");
          T2CKPS1_bit=1;
          T2CKPS0_bit=0;
          TMR2ON_bit=1;
        }
          p1=strstr(Buffer1,"ME");
        if (p1>0)
        {
          TMR2ON_bit=0;
          CPrint("\r\n set Prescaler  1/4 \r\n");
          T2CKPS1_bit=0;
          T2CKPS0_bit=1;
          TMR2ON_bit=1;
        }
        
     }
      if ( Drapeaux.Duty_Cde_Mode==1)
      {
        CRLF1();
         DutyVal=(unsigned char)(EA0 >>2);
         TMR2ON_bit=0;
         CCPR1L=DutyVal;
         TMR2ON_bit=1;
       }
     Lcd_Cmd(_LCD_FIRST_ROW );
     strcpy(CRam1,"Duty Value=     ");
     ByteToStr(DutyVal,CRam1+13);
     *(CRam1+16)=0 ;
     Lcd_Out_CP(CRam1);
     SQA=1;
     Print(CRam1);
     CRLF1();
     SQA=0;
      #ifdef With_ADC
      cx=0;
      EA0=ADC_Average_of_16_Reading(cx);    // maxi=1023
      #endif
     CRLF1();
   }

}   
/*


 Presentation :
 MikroC 7.60. & Microchip IRDA board 16F887 (ex 16F877)
 Directory : C:\_MikroC\_MesProjets_MikroC\_16F877_IRDA_Board
 Project : 16F887_IRDA_board_Tests_PWM_with_Fosc_8Mhz_2020.mcppi
 Source : _16F887_Irdaboard_Tests_PWM_at_8Mhz_2020_1004.c_2020_1004.c
 Fosc = Internal FOSC 8MHz
 EEPROM : 16F887_IRDA_daboard_Tests_minima_Freq_PWM_with_Fosc_8Mhz_2020_EEPROM.ihex
 TEST PWM : sortie sur RC2

 Reset du MCP2150, pour utiliser RX UART
<FF>ADC Init
 Init LCD
 Power On (RD5) and Init LCD
 Test PWM  at FOSC=20MHz  Post-scaler Non Utilis! PR2=255
 Prescaler  :  avec 1/16  Freq= 490 Hz
 Choix Prescaler : HIGH  MEDIUM  LOW
 Duty_Cde_Mode via Keyboard  Duty=xxx

Duty Value=  127

 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
Duty Value=  127

 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
Duty Value=  127

 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
 EA0 =>   414	  414	  414	  414	  414	  414	  414	  414
Duty Value=  127



*/